format zx81
;labelusenumeric
;LISTON

	// hardware options to be set and change defaults in ZX81DEF.INC
	MEMAVL	   =	   MEM_1K	  // can be MEM_1K, MEM_2K, MEM_4K, MEM_8K, MEM_16K, MEM_32K, MEM_48K
					   // default value is MEM_16K
	STARTMODE  EQU	   SLOW_MODE	   // SLOW or FAST
	DFILETYPE  EQU	   COLLAPSED		// COLLAPSED or EXPANDED or AUTO
	STARTUPMSG EQU	  'GUESS: 0000->9999' // any message will be shown on screen after loading, max. 32 chars

	//

	include 'SINCL-ZX\ZX81.INC'	   // definitions of constants
	//include 'SINCL-ZX\ZX81VARS.INC'        // definitions of constants

;LISTON


// MASTERMIND

// (C) 1978 by Paolo Forlani
// (C) 2014 by Stefano Bodrato


//AUTORUN:
	AUTOLINE 10

10	REM _asm

NUMI  EQU MEMBOT
NUMJ  EQU MEMBOT+1
NN    EQU MEMBOT+2
NPI   EQU MEMBOT+6
PUNT  EQU MEMBOT+10
NUMH  EQU MEMBOT+11
NUMF  EQU MEMBOT+12

BLANKTXT EQU MEMBOT+13


	LD C,6
ROWS:
	LD B,32
FILLROW:
	LD A,,':'
	RST $10
	DJNZ FILLROW
	LD A,NEWLINE
	RST $10
	DEC C
	JR NZ,ROWS

	RST $10
	CALL $B8E ; Make space for messages


	LD A,,'.'
	LD (MEMBOT+13+14),A


	LD DE,STARTMSG
	CALL MSG

STAR1:

	CALL WKEY1
STAR2:
	LD A,E
	ADD A,1
	DAA
	LD E,A
	LD A,D
	ADC A,0
	DAA
	LD D,A	; BCD

	CALL GKEY
	JR C,STAR2

	LD HL,NN
	LD A,E
	CALL STA
	LD A,D
	CALL STA	   ; load number N
	LD HL,PUNT
	LD (HL),0	   ; M=0
RITO1:
	LD DE,GUESSMSG
	CALL MSG

	LD HL,NUMI
	LD (HL),3	   ; I=3
	XOR A
	LD (NUMH),A	   ; H=0
	LD (NUMF),A	   ; F=0
		
	LD A,$16	   ;'-'
	CALL FILL	   ; P=----

STAR4:	CALL INTRD	   ; insert a digit
	LD A,(NUMI)
	LD (NUMJ),A	   ; J=I
	CALL CNFR	   ; compare P[I] with N[J]
	JR Z,DISPH
	LD A,3
	LD (NUMJ),A	   ; J=3

RITO2:	CALL CNFR	   ; compare
	JR Z,DISPF
	LD A,(NUMJ)
	OR A
	JR Z,USCIT	   ; J=0?
	LD HL,NUMJ
	DEC (HL)	   ; J=J-1
	JR RITO2

DISPH:	LD HL,NUMH
	INC (HL)	   ; H=H+1
	JR USCIT
DISPF:	LD HL,NUMF
	INC (HL)	   ; F=F+1

USCIT:	CALL DISPP
	LD A,(NUMI)
	OR A
	JR Z,MINCR	   ; I=0?
	DEC A
	LD (NUMI),A	   ; I=I-1
	JR STAR4

MINCR:	LD A,(PUNT)
	ADD A,1
	DAA
	LD (PUNT),A	   ; M=M+1
	LD C,4
	LD HL,NPI
	LD DE,NN
LOPO:	LD A,(DE)
	CP (HL)
	JR NZ,RITO9

	INC HL
	INC DE
	DEC C
	JR NZ,LOPO	   ; P=N?

	; NUMBER FOUND
	CALL WKEY1

	//LD   A,47          ; CPL
	//LD   (INVRS),a
	LD A,$17	   ; RRA
	LD (ROTATE),A
	CALL DISPP

	LD DE,WINMSG
	CALL MSG

USCI5:
	CALL GKEY
	JR C,USCI5
	CALL WKEY1

	LD A,$1F	   ; RLA
	LD (ROTATE),A
	//XOR A
	//LD   (INVRS),A     ; NOP

USCI2:	LD HL,NPI
	LD A,(PUNT)	   ; FINAL SCORE
	CALL STA
	LD A,0Fh	   ; ' '
	LD (HL),A
	INC HL
	LD (HL),A	   ; P=M
	CALL DISPP	   ; display M

	LD DE,SCOREMSG
	CALL MSG

	JP STAR1

RITO9:	LD DE,BLANKTXT
	CALL MSG

	CALL TIMER	   ; abt 1 second
	LD A,(NUMF)
	LD (NPI),A
	LD A,(NUMH)
	LD (NPI+2),A
	LD A,0Fh
	LD (NPI+1),A
	LD (NPI+3),A	   ; P = F H
	CALL DISPP	   ; display F H
	CALL TIMER	   ; 1 second
	JP RITO1

	RET


; -------------------------------------------------

MSG:
	LD  HL,(16396)	  ; D_FILE
	LD  BC,33*6+4
	ADD HL,BC
MSGLOOP:
	LD  A,(DE)
	CP ,'.'
	RET Z
	LD (HL),A
	INC HL
	INC DE
	JR MSGLOOP


STARTMSG:
	DBZX 'PRESS ANY KEY.'

GUESSMSG:
	DBZX 'YOUR GUESS ? .'

WINMSG:
	DBZX 'Y O U   W I N.'

SCOREMSG:
	DBZX '   YOUR SCORE.'

; -------------------------------------------------



STA:	PUSH AF
	AND $0F
	LD (HL),A
	INC HL
	POP AF
	AND $F0
	RRCA
	RRCA
	RRCA
	RRCA
	LD (HL),A
	INC HL
	RET


CNFR:	PUSH HL 	   ; COMPARE digit I of P and digit J of N
	PUSH BC 	   ; ZF is set if they match
	PUSH DE
	LD A,(NUMI)
	LD C,A
	LD B,0
	LD A,(NUMJ)
	LD E,A
	LD D,0
	LD HL,NPI
	ADD HL,BC
	LD A,(HL)
	LD HL,NN
	ADD HL,DE
	CP (HL)
	POP DE
	POP BC
	POP HL
	RET


TIMER:	PUSH DE 	   ; TIMER: about 1 second delay subroutine
	LD DE,47000
TIME1:	DEC DE
	LD A,D
	OR E
	JR NZ,TIME1
	POP DE
	RET


; FILL the 4 chars display with digit in A
FILL:
	LD   B,4
	LD   HL,NPI
STAR3:	LD   (HL),A
	INC  HL
	DJNZ STAR3
; oooooooooooooooooooooooooooooooooooooooo

; copy number in NPI to display
DISPP:	PUSH HL 	   ; put P on the DISPLAY
	PUSH DE

	LD   B,4
	LD   HL,NPI+3
	LD   DE,(16396)    ; D_FILE
	INC  DE
DISPLOOP:
	LD   A,(HL)
	CP   $0F ; ' '
	JR   NZ,NOBLANK
	XOR  A
	JR   OUTCHAR
NOBLANK:
	CP   $16
	JR   Z,OUTCHAR
	ADD  A,28

OUTCHAR:
	PUSH BC
	PUSH HL   ; NPI
	PUSH DE   ; D-FILE

	LD HL,$1E00
	LD D,L
	LD E,A
	SLA E
;        RL D
	SLA E
;        RL D
	SLA E
	RL D
	ADD HL,DE

	EX (SP),HL  ; HL = current PTR to D-FILE
	POP DE	    ; DE = PTR to character set

	PUSH HL     ; prepare ptr for nex digit in D-FILE
	LD BC,8
	ADD HL,BC
	EX (SP),HL  ; HL = current PTR to D-FILE, (SP) = next digit position

	LD B,6
ROWLOOP:
	INC DE	    ; Get next byte from character set
	LD  A,(DE)
	RLA
	PUSH BC

//INVRS:  NOP         ; Self modifying code, gets to "CPL" to invert the display

	LD C,A
	LD B,7
COLOOP:
	XOR A
	RL C
ROTATE: RRA	      ; 0 or 128  (also RLA gives a nice effect !)
	LD (HL),A
	INC HL
	DJNZ COLOOP
	LD BC,26
	ADD HL,BC     ; point to next row for digit
	POP BC
	DJNZ ROWLOOP

	POP DE
	POP HL
	POP BC

	DEC  HL
	DJNZ DISPLOOP


	POP DE
	POP HL
;        POP BC
	RET

; oooooooooooooooooooooooooooooooooooooooo
GKEY:	PUSH DE
	CALL $2BB
	LD A,H
	ADD A,2
	POP DE
	RET

WKEY1:	CALL GKEY
	JR NC,WKEY1
	RET


; Wait for a key being pressed, then put the
; corresponding BCD value in digit #I of P
INTRD:	PUSH HL 	   ; insert a digit
	PUSH DE
	PUSH BC
	CALL WKEY1
WKEY2:
	CALL GKEY
	JR C,WKEY2
	LD B,H
	LD C,L
	CALL $7BD
	LD A,(HL)
	SUB 28
	CP 10
	JR C,ISDIGIT
	LD A,128-28
ISDIGIT:
	LD B,A
	LD A,(NUMI)
	LD E,A
	LD D,00h
	LD HL,NPI
	ADD HL,DE
	LD (HL),B
	POP BC
	POP DE
	POP HL
	RET


	END _asm

	RAND USR #10#



// list of supported BASIC statements in version 1.71.01e.Z80 (08/2013)


	include 'SINCL-ZX\ZX81POST.INC' 	 ; include D_FILE and needed memory areas

assert ($-MEMST)<MEMAVL
// end of program


